/////////////////////////////////
// MyControl.h : Declaration of the CMyControl
//
// (720020-1160x) WebCOM : an IE-enabled COM control
// Applied Data Systems
//
// Description
// -----------
// This simple control shows how to enable browser support for COM controls in CE.
// This control draws some circles on the browser window
//
// To use it, pase the following into an HTML document
//
//
// History
// -------
// 720020-11601 - Sept. 17, 2003 (ctacke)
//   - Intial Release
//
/////////////////////////////////


#ifndef __MYCONTROL_H_
#define __MYCONTROL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CMyControl
class ATL_NO_VTABLE CMyControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CMyControl, IMyControl, &IID_IMyControl, &LIBID_WebCOM>,
	public CComControl<CMyControl>,
	public IPersistStreamInitImpl<CMyControl>,
	public IOleControlImpl<CMyControl>,
	public IOleObjectImpl<CMyControl>,
	public IOleInPlaceActiveObjectImpl<CMyControl>,
	public IViewObjectExImpl<CMyControl>,
	public IOleInPlaceObjectWindowlessImpl<CMyControl>,
	public IPersistStorageImpl<CMyControl>,
	public ISpecifyPropertyPagesImpl<CMyControl>,
	public IQuickActivateImpl<CMyControl>,
	public IDataObjectImpl<CMyControl>,
	public IProvideClassInfo2Impl<&CLSID_MyControl, NULL, &LIBID_WebCOM>,
	public CComCoClass<CMyControl, &CLSID_MyControl>,

	public IObjectSafety // ******* For IE Creation support *******

{
public:
	CContainedWindow m_ctlStatic;
	

	CMyControl() :	
		m_ctlStatic(_T("Static"), this, 1)
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MYCONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMyControl)
	COM_INTERFACE_ENTRY(IMyControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IObjectSafety) // ******* For IE Creation support *******
END_COM_MAP()

BEGIN_PROP_MAP(CMyControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CMyControl)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	CHAIN_MSG_MAP(CComControl<CMyControl>)
ALT_MSG_MAP(1)
	// Replace this with message map entries for superclassed Static
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);


	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<CMyControl>::OnSetFocus(uMsg, wParam, lParam, bHandled);
		if (m_bInPlaceActive)
		{
			DoVerbUIActivate(&m_rcPos,  NULL);
			if(!IsChild(::GetFocus()))
				m_ctlStatic.SetFocus();
		}
		return lRes;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left;
		rc.bottom -= rc.top;
		rc.top = rc.left = 0;
		m_ctlStatic.Create(m_hWnd, rc);
		return 0;
	}


	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CMyControl>::SetObjectRects(prcPos, prcClip);
		int cx, cy;
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top;
		::SetWindowPos(m_ctlStatic.m_hWnd, NULL, 0,
			0, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

   // ----------------- Begin IObjectSafety implementation ---------------------
   STDMETHODIMP GetInterfaceSafetyOptions( REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions )

   {
      ATLTRACE(_T("CNoteCtl::GetInterfaceSafetyOptions()\n"));
   
      *pdwSupportedOptions = INTERFACESAFE_FOR_UNTRUSTED_CALLER |
                             INTERFACESAFE_FOR_UNTRUSTED_DATA;
      *pdwEnabledOptions = *pdwSupportedOptions;
      return S_OK;
   }

   STDMETHODIMP SetInterfaceSafetyOptions(REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions)
   {
      ATLTRACE(_T("CNoteCtl::SetInterfaceSafetyOptions\n"));
      return S_OK;
   }
   // ----------------- End IObjectSafety implementation ---------------------

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

	HRESULT OnDraw(ATL_DRAWINFO & di);

// IMyControl
};

#endif //__MYCONTROL_H_
